// Result.cpp : t@C
//

#include "stdafx.h"
#include "client.h"  // CN[ht@C\VC  Result.cpp ƓfBNgɃRs[Ă
#include "sample.h"
#include "Result.h"

static RealDataInfo     g_RealStockDatas;

const MarketName gMarketMenu[] = {
	{ 1, _T("؃vC") }, 
	{ 2, _T("؃X^_[h") }, 
	{ 4, _T("؂P") }, 
	{ 8, _T("؂Q") }, 
	{ 16, _T("؃v~A") }, 
	{ 32, _T("؃C") }, 
	{ 64, _T("") }, 
	{ 128, _T("D") }, 
	{ 256, _T("؃O[X") }, 
	{ 512, _T("JASDAQ") }, 
	{ 1024, _T("wNX") }, 
	{ 2048, _T("؃lNXg") }, 
	{ 0, NULL }
};


const ExchangeName gExNameMenu[] = {
	{ 1, _T("AJh") },
	{ 2, _T("[") },
	{ 4, _T("I[XgAh") },
	{ 8, _T("CMX|h") },
	{ 0, NULL }
};

// CResult _CAO

IMPLEMENT_DYNAMIC(CResult, CDialog)

CResult::CResult(CWnd* pParent /*=NULL*/)
	: CDialog(CResult::IDD, pParent)
	, m_lapseTime(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	ZeroMemory(&g_RealStockDatas, sizeof(RealDataInfo));
	mDataKind = -1;
}

CResult::~CResult()
{
}


BEGIN_MESSAGE_MAP(CResult, CDialog)
END_MESSAGE_MAP()

void CResult::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RESULT, m_xcList);
	DDX_Text(pDX, IDC_LAPSE, m_lapseTime);
	DDX_Control(pDX, IDC_DATANUM, m_DataNum);
}

BOOL CResult::OnInitDialog()
{
	// AwWf[^\z
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// Rg[Xg
	m_DataNum.SetWindowText("");
	m_xcList.DeleteAllItems ();
	if(ListInit()){
		// G[
		AfxMessageBox("Xg̏Ɏs܂", MB_OK|MB_ICONEXCLAMATION);
		return false;
	}
	if(InsertData()){
		// G[
		AfxMessageBox("Xg̍쐬Ɏs܂", MB_OK|MB_ICONEXCLAMATION);
		return false;
	}
	UpdateData(FALSE);
	ShowWindow(SW_SHOW);

	return TRUE;
}


// CResult bZ[W nh

int CResult::ListInit()
{
	// Xg
	LVCOLUMN    lvc;
	int         aCount;
	int         aErr = 0;
	TCHAR       caption[16][32];
	switch(mDataKind){
		case 1: /* Pw */
		case 2: /* w */
			// TCHAR    caption[][32] = {_T("،R[h"),_T(""),_T(""),_T("@t"),_T("@"),_T("ݒl"),_T("nߒl"),_T("l"),_T("l"),_T("o"),_T("O"),_T("Cz"),_T("Cz")};
			_tcscpy_s(caption[0], 32, _T("،R[h"));
			_tcscpy_s(caption[1], 32, _T(""));
			_tcscpy_s(caption[2], 32, _T(""));
			_tcscpy_s(caption[3], 32, _T("@t"));
			_tcscpy_s(caption[4], 32, _T("@"));
			_tcscpy_s(caption[5], 32, _T("ݒl"));
			_tcscpy_s(caption[6], 32, _T("nߒl"));
			_tcscpy_s(caption[7], 32, _T("l"));
			_tcscpy_s(caption[8], 32, _T("l"));
			_tcscpy_s(caption[9], 32, _T("o"));
			_tcscpy_s(caption[10], 32, _T("O"));
			_tcscpy_s(caption[11], 32, _T("Cz"));
			_tcscpy_s(caption[12], 32, _T("Cz"));
			break;
		case 3: /* wW */
			//TCHAR    caption[][32] = {_T("wWR[h"),_T("wW"),_T("@t"),_T("@"),_T("ݒl"),_T("nߒl"),_T("l"),_T("l"),_T("-----"),_T("-----"),_T("-----"),_T("-----"),_T("-----")};
			_tcscpy_s(caption[0], 32, _T("wWR[h"));
			_tcscpy_s(caption[1], 32, _T("wW"));
			_tcscpy_s(caption[2], 32, _T("@t"));
			_tcscpy_s(caption[3], 32, _T("@"));
			_tcscpy_s(caption[4], 32, _T("ݒl"));
			_tcscpy_s(caption[5], 32, _T("nߒl"));
			_tcscpy_s(caption[6], 32, _T("l"));
			_tcscpy_s(caption[7], 32, _T("l"));
			_tcscpy_s(caption[8], 32, _T("-----"));
			_tcscpy_s(caption[9], 32, _T("-----"));
			_tcscpy_s(caption[10], 32, _T("-----"));
			_tcscpy_s(caption[11], 32, _T("-----"));
			_tcscpy_s(caption[12], 32, _T("-----"));
			break;
		case 0: /* ̂ */
			// TCHAR    caption[][32] = {_T("،R[h"),_T(""),_T(""),_T("@t"),_T("@"),_T("ݒl"),_T("nߒl"),_T("l"),_T("l"),_T("o"),_T("O"),_T("Cz"),_T("Cz")};
			_tcscpy_s(caption[0], 32, _T("،R[h"));
			_tcscpy_s(caption[1], 32, _T(""));
			_tcscpy_s(caption[2], 32, _T(""));
			_tcscpy_s(caption[3], 32, _T("-----"));
			_tcscpy_s(caption[4], 32, _T("-----"));
			_tcscpy_s(caption[5], 32, _T("-----"));
			_tcscpy_s(caption[6], 32, _T("-----"));
			_tcscpy_s(caption[7], 32, _T("-----"));
			_tcscpy_s(caption[8], 32, _T("-----"));
			_tcscpy_s(caption[9], 32, _T("-----"));
			_tcscpy_s(caption[10], 32, _T("-----"));
			_tcscpy_s(caption[11], 32, _T("-----"));
			_tcscpy_s(caption[12], 32, _T("-----"));
			break;
		default: 
			aErr = 1;
			break;
	}
	if(aErr) return aErr;

	const int  aColNum = 13; // ڐ
	m_font.CreatePointFont(120, _T("MS UI Gothic"));
	m_xcList.SetFont(&m_font);
	m_xcList.SetExtendedStyle(m_xcList.GetExtendedStyle() | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );
	lvc.mask = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	for(aCount = 0;aCount < aColNum; aCount++){
		lvc.iSubItem = aCount;
		lvc.pszText  = caption[aCount];
		lvc.cx       = 120;
		if(m_xcList.InsertColumn (aCount,&lvc)== -1){
			aErr=1;
			break;
		}
	}
	return aErr;
}

int CResult::InsertData()
{
	// XgɃf[^i[
	LVITEM    lvi;
	CString   str;
	int       aCount, aIndex=0;
	int       aErr=0;
	TCHAR     aBlank[] = " ";
	TCHAR     aNum[8];

	switch(mDataKind){
		case 1:  /* Pw */
		case 2:  /* w */
			for(aCount=0;aCount<g_RealStockDatas.DataNum ;aCount++){
				// ITEMɃf[^i[
				lvi.mask = LVIF_TEXT;
				// ،R[h
				str.Format (_T("%s"), g_RealStockDatas.StockData[aCount].Code );
				lvi.iItem = aCount;
				lvi.iSubItem = 0;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				aIndex = m_xcList.InsertItem (&lvi);
				if(aIndex == -1){ aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 1;
				lvi.pszText = g_RealStockDatas.StockData[aCount].Name;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 2;
				lvi.pszText = ConvertMarketCodeToName(g_RealStockDatas.StockData[aCount].Market);
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// t
				lvi.iItem = aIndex;
				lvi.iSubItem = 3;
				lvi.pszText = g_RealStockDatas.StockData[aCount].DateInfo.DealingDate ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 4;
				lvi.pszText = g_RealStockDatas.StockData[aCount].DateInfo.DealingTime ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// ݒl
				str.Format (_T("%.1f"), g_RealStockDatas.StockData[aCount].Current );
				lvi.iItem = aIndex;
				lvi.iSubItem = 5;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// nߒl
				str.Format (_T("%.1f"), g_RealStockDatas.StockData[aCount].Start );
				lvi.iItem = aIndex;
				lvi.iSubItem = 6;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// l
				str.Format (_T("%.1f"), g_RealStockDatas.StockData[aCount].Low );
				lvi.iItem = aIndex;
				lvi.iSubItem = 7;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// l
				str.Format (_T("%.1f"), g_RealStockDatas.StockData[aCount].High );
				lvi.iItem = aIndex;
				lvi.iSubItem = 8;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// o
				str.Format (_T("%d"), g_RealStockDatas.StockData[aCount].Amount);
				lvi.iItem = aIndex;
				lvi.iSubItem = 9;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// O
				str.Format (_T("%.1f"), g_RealStockDatas.StockData[aCount].Ratio );
				lvi.iItem = aIndex;
				lvi.iSubItem = 10;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// Cz
				str.Format (_T("%.1f"), g_RealStockDatas.StockData[aCount].SellConsideration );
				lvi.iItem = aIndex;
				lvi.iSubItem = 11;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// Cz
				str.Format (_T("%.1f"), g_RealStockDatas.StockData[aCount].BuyConsideration );
				lvi.iItem = aIndex;
				lvi.iSubItem = 12;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
			}
			break;
		case 3:
			// wW
			for(aCount=0;aCount<g_RealStockDatas.DataNum ;aCount++){
				// ITEMɃf[^i[
				lvi.mask = LVIF_TEXT;
				// wWR[h
				str.Format (_T("%d"), g_RealStockDatas.IndexData[aCount].IndexType);
				lvi.iItem = aCount;
				lvi.iSubItem = 0;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				aIndex = m_xcList.InsertItem (&lvi);
				if(aIndex == -1){ aErr=1; break;}
				// wW
				lvi.iItem = aIndex;
				lvi.iSubItem = 1;
				lvi.pszText = g_RealStockDatas.IndexData[aCount].Name ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// t
				lvi.iItem = aIndex;
				lvi.iSubItem = 2;
				lvi.pszText = g_RealStockDatas.IndexData[aCount].DateInfo.DealingDate ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 3;
				lvi.pszText = g_RealStockDatas.IndexData[aCount].DateInfo.DealingTime ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// ݒl
				str.Format (_T("%.2f"), g_RealStockDatas.IndexData[aCount].Current );
				lvi.iItem = aIndex;
				lvi.iSubItem = 4;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// nߒl
				str.Format (_T("%.2f"), g_RealStockDatas.IndexData[aCount].Start );
				lvi.iItem = aIndex;
				lvi.iSubItem = 5;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// l
				str.Format (_T("%.2f"), g_RealStockDatas.IndexData[aCount].Low );
				lvi.iItem = aIndex;
				lvi.iSubItem = 6;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// l
				str.Format (_T("%.2f"), g_RealStockDatas.IndexData[aCount].High );
				lvi.iItem = aIndex;
				lvi.iSubItem = 7;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 8;
				lvi.pszText = aBlank;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 9;
				lvi.pszText = aBlank;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 10;
				lvi.pszText = aBlank;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 11;
				lvi.pszText = aBlank;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 12;
				lvi.pszText = aBlank;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
			}
			break;
		case 0:
			// 
			for(aCount=0;aCount<g_RealStockDatas.DataNum ;aCount++){
				// ITEMɃf[^i[
				lvi.mask = LVIF_TEXT;
				// ،R[h
				str.Format (_T("%s"), g_RealStockDatas.StockData[aCount].Code );
				lvi.iItem = aCount;
				lvi.iSubItem = 0;
				lvi.pszText = const_cast<LPTSTR>(static_cast<LPCTSTR>(str));
				aIndex = m_xcList.InsertItem (&lvi);
				if(aIndex == -1){ aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 1;
				lvi.pszText = g_RealStockDatas.StockData[aCount].Name;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 2;
				lvi.pszText = ConvertMarketCodeToName(g_RealStockDatas.StockData[aCount].Market);
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 3;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 4;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 5;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 6;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 7;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 8;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 9;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 10;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 11;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
				// 
				lvi.iItem = aIndex;
				lvi.iSubItem = 12;
				lvi.pszText = aBlank ;
				if(!m_xcList.SetItem(&lvi)){aErr=1; break;}
			}
			break;
		default:
			aErr=1;
			break;
	}
	sprintf_s(aNum, sizeof(aNum), "%d", g_RealStockDatas.DataNum);
	m_DataNum.SetWindowText(aNum);
	return aErr;
}

TCHAR*  CResult::ConvertMarketCodeToName(unsigned long InCode)
{
	const MarketName     *marketptr;

	for(marketptr = gMarketMenu; marketptr->code != 0 && marketptr->name ; ++marketptr){
		if(marketptr->code == InCode) break;
	}
	
	return (marketptr->code == 0) ? _T("YsȂ") : marketptr->name ;
}

int    CResult::mSetObtainedData(int inKind, RealDataInfo* inData)
{
	mDataKind = inKind;
	ZeroMemory(&g_RealStockDatas, sizeof(RealDataInfo));
	g_RealStockDatas = *inData;
	return 0;
}