//
// 
// A^C擾Cuwb_
// 
//
#ifndef _CLIENT_H_
#define _CLIENT_H_



/* }N鐾 */


#define MAX_BRAND_DATA               9999            /* ő吔 */
#define MAX_STOCKDATA_NUMBER         MAX_BRAND_DATA  /* 󂯓nő擾R[h */
#define MAX_EXCHANGEDATA_NUMBER      10              /* בփ[g̃R[h */
#define MAX_INDEXDATA_NUMBER         20              /* wW̃R[h */
#define MAX_FUTUREDATA_NUMBER        20              /* 敨̃R[h */


//
// 񋓐鐾
//

/* oG[R[h */
typedef enum _tagErrorInfo {
	DETECT_ERROR = 60001,
	NOT_ALL_DATA_STORE_ERROR,    /* S̗vꂽR[hĂȂ */
	NOT_ALL_ITEM_DATA_ERROR,     /* S̍ڃf[^Ȃ */
	ILLEGAL_FUNCTION_ERROR,      /* @\wG[ AבցA敨AwWȊOw肵 */
	MISC_ERROR
} ErrorInfo;

// Ăяo֒ʒmԃR[h
typedef enum _tagResultStatus {
	LOGIN_ACCOUNT_OK = 61000,
	LOGOUT_ACCOUNT_OK,
	LOGIN_ACCOUNT_ERROR = 61100,
	LOGIN_ACCOUNT_VALIDITY_ERROR,
	ACCOUNT_SESSION_ERROR,
	ACCOUNT_SESSION_TIMEOUT_ERROR,
	DATA_PARAMETER_ERROR,
	DATA_REQUEST_ERROR,
	DATA_DESTRUCTION_ERROR,
	REQ_DATA_NOT_FOUND,          /* vR[hAтɏ،R[h̃f[^Ȃ */
	DATA_SOURCE_ERROR = 61198,
	DATAHOST_SYSTEM_ERROR,
	DATAFILE_NOTFOUND = 61200,
	DATAFILE_PATH_NOT_FOUND,
	TIME_PROCEED_ERROR = 62000
} ResultStatus;


/* f[^擾pv */
typedef enum _tagRequestDataKind {
	STOCKDATA_SINGLE,  /* P擾p */
	STOCKDATA_PLURAL,  /* 擾p */
	STOCKDATA_LIST,    /* Xg擾p */
	INDEX_DATA,        /* wW擾p */
	FUTURE_DATA,       /* 敨 */
	EXCHANGE_DATA      /* ב */
} RequestDataKind;

/* sʃR[h */
typedef enum _tagMarketStatusCodes {
	MARKET_ALL = 0,             /* Ss */
	MARKET_TOKYO_PRIME = 1,     /* ؃vC */
	MARKET_TOKYO_STD = 2,       /* ؃X^_[h */
	MARKET_OSAKA_1 = 4,         /* ؂P */
	MARKET_OSAKA_2 = 8,         /* ؂Q */
	MARKET_NAGOYA_PREMIER = 16, /* ؃v~A */
	MARKET_NAGOYA_MAIN = 32,    /* ؃C */
	MARKET_FUKUOKA = 64,        /*      */
	MARKET_SAPPORO = 128,       /* D     */
	MARKET_TOKYO_GROWTH = 256,  /* ؃O[X */
	MARMET_JASDAQ = 512,        /* JASDAQ   */
	MARKET_HERCULES = 1024,     /* wNX */
	MARKET_NAGOYA_NEXT = 2048   /* ؃lNXg */
} MarketStatusCodes;

/* f[^foʃR[h */
typedef enum _tagStockDataReqType{
	ALL_STOCK_DATA = 0,              /* S */
	LIST_STOCK_DATA,                 /*  */
	BASIC_STOCK_DATA,                /* { */
	ALL_STOCK_DATA_INC_ALPHABET = 4, /* S(p܂) */
	LIST_STOCK_DATA_INC_ALPHABET,    /* (p܂) */
	BASIC_STOCK_DATA_INC_ALPHABET,   /* {(p܂) */
} StockDataReqType;


/* t */
typedef enum _tagTimeFormatType{
	IsMonthDate,             /* t̃tH[}bg^Cv (XX/YY) */
	IsHourMinutes,           /* Ԃ̃tH[}bg^Cv (XX:YY) */
	IsInvalidTime = -1
} TimeFormatType;


/* wW */
typedef enum _tagIndexRequestType{
	INDEX_ALL,            /* SwW */
	INDEX_TOPIX,          /* TOPIX */
	INDEX_NIKKEI,         /* oϊ */
	INDEX_JASDAQ=4,       /* JSADAQ */
	INDEX_TOKYO_GROWTH=8, /* ؃O[XsCore w */
	INDEX_TOKYO_STD=16    /* ؃X^_[hsTOP20 */
} IndexRequestType;



/* \̐鐾 */


typedef struct _tagDateTimeInfo {
	unsigned long Year;
	unsigned long Month;
	unsigned long Day;
	unsigned long Hour;
	unsigned long Minutes;
	char           DealingDate[16];      /*  */
	char           DealingTime[8];       /*  */
} DateTimeInfo;


/* Avv(f[^) */
typedef struct _tagRequestStockParam{
	unsigned long    sType;      /* vf[^ڂ̐ StockDataReqTypeo */
	char             scode[8];   /* JnR[h */
	char             ecode[8];   /* IR[h(P̎ɂ͖) */
	unsigned long    market;     /* ̏ꍇ̎s MarketStatusCodes  ogݍ킹w */
} RequestStockParam;
/* Avv(wWf[^) */
typedef struct _tagRequestIndexParam{
	unsigned long    IndexType;  /* IndexRequestType o */
} RequestIndexParam;

/* A^CpAJEg */
typedef struct _tagAuthMemberInfo
{
    char id[32];
    char pass[32];
	char vendor[32];
	char sessionkey[33];
} AuthMemberInfo;

/* Avv(||ɂP) */
typedef struct _tagRequestDataInfo{
    unsigned long         ReqKind;      /* v(PAAבւAwWA敨) */
	RequestStockParam     StockParam;   /* f[^vp[^ */
	RequestIndexParam     IndexParam;   /* wWf[^vp[^ */
	AuthMemberInfo        MemberParam;  /* F؏ */
	unsigned long         Method;       /* 0: Ȃ 1:t@CL^{  */
	char                  SaveFile[MAX_PATH];   /* t@C󂯎̎̕ۑt@CtpX(260) */
} RequestDataInfo;




/* ̊ */
typedef struct _tagRealStockDataValues {
	unsigned long  IsValid;               /* L(=1)(=0)H */
	DateTimeInfo   DateInfo;              /* ԏ   */
	char           Code[8];               /* R[h */
	unsigned long  Market;                /* }[Pbg MarketStatusCodes o */
	char           Name[80];              /*  */
	char           Yomi[80];              /* ǂ */
	double         Current;               /* ݂̎l */
	double         Ratio;                 /* O    */
	double         Start;                 /* nl      */
	double         Low;                   /* l      */
	double         High;                  /* l      */
	double         End;                   /* OIl(Af[^ł͈ӖȂȂ)  */
	unsigned long  Amount;                /* o    */
	unsigned long  Unit;                  /* Pʊ  */
	unsigned long  IssueStock;            /* sς݊ */
	double         SellConsideration;     /* Cz(P{)  */
	double         BuyConsideration;      /* Cz(P{)  */
	double         SellConsideration7th;  /* V{  */
	double         SellConsideration6th;  /* U{  */
	double         SellConsideration5th;  /* T{  */
	double         SellConsideration4th;  /* S{  */
	double         SellConsideration3rd;  /* R{  */
	double         SellConsideration2nd;  /* Q{  */
	double         SellConsideration1st;  /* P{  */
	double         BuyConsideration1st;   /* P{  */
	double         BuyConsideration2nd;   /* Q{  */
	double         BuyConsideration3rd;   /* R{  */
	double         BuyConsideration4th;   /* S{  */
	double         BuyConsideration5th;   /* T{  */
	double         BuyConsideration6th;   /* U{  */
	double         BuyConsideration7th;   /* V{  */
	unsigned long  Concession1;           /* ݒl1 */
	unsigned long  Concession2;           /* ݒl2 */
	unsigned long  Concession3;           /* ݒl3 */
	unsigned long  Concession4;           /* ݒl4 */
} RealStockDataValues;

/* AvɕԂ  wW */
typedef struct _tagRealIndexDataValue {
	unsigned long    IsValid;              /* L(=1) */
	unsigned long    IndexType;            /* wWR[h IndexRequestTypeo */
	DateTimeInfo     DateInfo;                /* ԏ   */
	char             Name[80];             /* wW */
	double           Start;                /* nߒl  */
	double           High;                 /* l  */
	double           Low;                  /* l  */
	double           Current;              /* ݂̎l */
	double           Ratio;                /* O */
} RealIndexDataValue;


/* AvɕԂ   */
typedef struct _tagRealDataInfo {
	long                 DataNum;     /* vAтɎ擾łf[^̑ */
	long                 IsRemain;    /* cf[^邩(=1 ) */
	unsigned long       Month;       /* ̌(gp)  */
	unsigned long       Day;         /* ̓(gp)  */
	unsigned long        ContentsSize;  /* URLRecTCY */
	RealStockDataValues  StockData[MAX_STOCKDATA_NUMBER];
	RealIndexDataValue   IndexData[MAX_INDEXDATA_NUMBER];
} RealDataInfo;

/* ߋf[^v */
typedef struct _tagRequestPastDataInfo{
	unsigned long     ReqType;          /* S=15, =1, T=2, =4, Mpc=8 */
	char              BrandCode[8];     /* R[h */
	unsigned long     MarketCode;       /* R[h */
	char              SaveDir[260];     /* ۑDir */
    AuthMemberInfo    MemberInfo;       /* o[ */
	unsigned long     OpMode;           /* ̗\p (Oŵ) */
} RequestPastDataInfo;



/* ֐鐾 IMPORT  */
extern "C" __declspec( dllimport ) long   __cdecl GetRealStockData(RequestDataInfo *InRequest,  RealDataInfo *DataInfo, char *&Datas, unsigned long *DataSize, long *GetRecords, long *OutStatus);
extern "C" __declspec( dllimport ) long   __cdecl AuthenticationToServer(AuthMemberInfo *InAuthInfo, long InMethod, long *OutStatus);
// ʃf[^擾p
extern "C" __declspec( dllimport ) long   __cdecl GetPastStockData(RequestPastDataInfo *InReqInfo, long *OutStatus);
// Xf[^擾p
extern "C" __declspec( dllimport ) long   __cdecl GetPastDailyData(RequestPastDataInfo *InReqInfo, long InDate, long *OutStatus);
// 擾w
extern "C" __declspec( dllimport ) long   __cdecl IndicateGetRealData(RequestDataInfo *InRequest,  long *RecordNum, long *OutStatus);
// ꊇ擾v
extern "C" __declspec( dllimport ) long   __cdecl GetRealStockDataOneTurn(long Mode, long Num, RealStockDataValues *Data, long *OutStatus);
// ꊇwW擾v
extern "C" __declspec( dllimport ) long   __cdecl GetRealIndexDataOneTurn(long Num, RealIndexDataValue *Data, long *OutStatus);


#endif  /* _CLIENT_H_ */
